<?php
/**
 * Clase Base DP para BaseCrCierrehipotecaCDP
 *
 * @package    
 * @subpackage BaseCrCierrehipotecaCDP
 * @author     Willy
 * @version    SVN:: BaseCrCierrehipotecaCDP.class.php,v 1.1 2013-02-06 11:51:29 william.taype Exp $
 */
abstract class BaseCrCierrehipotecaCDP extends CrCierrehipotecaCBN
{
  /* N�mero de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrCierrehipotecaCBN )
    {
      $o_CrCierrehipotecaCBN = $bSetDefault;
      if($o_CrCierrehipotecaCBN->getIdsucursal()) : $this->setIdsucursal($o_CrCierrehipotecaCBN->getIdsucursal()); endif;
      if($o_CrCierrehipotecaCBN->getFecha()) : $this->setFecha($o_CrCierrehipotecaCBN->getFecha()); endif;
      if($o_CrCierrehipotecaCBN->getNombresucursal()) : $this->setNombresucursal($o_CrCierrehipotecaCBN->getNombresucursal()); endif;
      if($o_CrCierrehipotecaCBN->getNombreadministrador()) : $this->setNombreadministrador($o_CrCierrehipotecaCBN->getNombreadministrador()); endif;
      if($o_CrCierrehipotecaCBN->getIngresototal()) : $this->setIngresototal($o_CrCierrehipotecaCBN->getIngresototal()); endif;
      if($o_CrCierrehipotecaCBN->getSalidatotal()) : $this->setSalidatotal($o_CrCierrehipotecaCBN->getSalidatotal()); endif;
      if($o_CrCierrehipotecaCBN->getSaldototal()) : $this->setSaldototal($o_CrCierrehipotecaCBN->getSaldototal()); endif;
      if($o_CrCierrehipotecaCBN->getObservacion()) : $this->setObservacion($o_CrCierrehipotecaCBN->getObservacion()); endif;
      if($o_CrCierrehipotecaCBN->getFecharegistro()) : $this->setFecharegistro($o_CrCierrehipotecaCBN->getFecharegistro()); endif;
      if($o_CrCierrehipotecaCBN->getUsuarioregistro()) : $this->setUsuarioregistro($o_CrCierrehipotecaCBN->getUsuarioregistro()); endif;
      if($o_CrCierrehipotecaCBN->getIdcolaborador()) : $this->setIdcolaborador($o_CrCierrehipotecaCBN->getIdcolaborador()); endif;
    }
  }

  /* Obtiene el n�mero de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      
      if($this->getIdsucursal() && $this->getFecha() && $this->getMoneda()){
        $a_Fields = array();

        if($this->getIdsucursal()) : $a_Fields['idsucursal'] = ($this->getIdsucursal()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;
        if($this->getMoneda()) : $a_Fields['moneda'] = ($this->getMoneda()); endif;
        if($this->getNombresucursal()) : $a_Fields['nombresucursal'] = ($this->getNombresucursal()); endif;
        if($this->getNombreadministrador()) : $a_Fields['nombreadministrador'] = ($this->getNombreadministrador()); endif;
        if($this->getIngresototal()) : $a_Fields['ingresototal'] = ($this->getIngresototal()); endif;
        if($this->getIngresototalga()) : $a_Fields['ingresototalga'] = ($this->getIngresototalga()); endif;
        if($this->getIngresototalDeposito()) : $a_Fields['ingresototaldeposito'] = ($this->getIngresototalDeposito()); endif;
        if($this->getSalidatotal()) : $a_Fields['salidatotal'] = ($this->getSalidatotal()); endif;
        if($this->getSaldototal()) : $a_Fields['saldototal'] = ($this->getSaldototal()); endif;
        if($this->getObservacion()) : $a_Fields['observacion'] = ($this->getObservacion()); endif;
        if($this->getFecharegistro()) : $a_Fields['fecharegistro'] = ($this->getFecharegistro()); endif;
        if($this->getUsuarioregistro()) : $a_Fields['usuarioregistro'] = ($this->getUsuarioregistro()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_cierrehipoteca_c (".$sStringField.") VALUES (".$sStringValue.");";
		//echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdsucursal() && $this->getFecha())
      {
        $a_Fields = array();

        if($this->getIdsucursal()) : $a_Fields['idsucursal'] = ($this->getIdsucursal()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;
        if($this->getNombresucursal()) : $a_Fields['nombresucursal'] = ($this->getNombresucursal()); endif;
        if($this->getNombreadministrador()) : $a_Fields['nombreadministrador'] = ($this->getNombreadministrador()); endif;
        if($this->getIngresototal()) : $a_Fields['ingresototal'] = ($this->getIngresototal()); endif;
        if($this->getSalidatotal()) : $a_Fields['salidatotal'] = ($this->getSalidatotal()); endif;
        if($this->getSaldototal()) : $a_Fields['saldototal'] = ($this->getSaldototal()); endif;
        if($this->getObservacion()) : $a_Fields['observacion'] = ($this->getObservacion()); endif;
        if($this->getFecharegistro()) : $a_Fields['fecharegistro'] = ($this->getFecharegistro()); endif;
        if($this->getUsuarioregistro()) : $a_Fields['usuarioregistro'] = ($this->getUsuarioregistro()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_cierrehipoteca_c SET ".$sStringField." WHERE 1 AND idsucursal='".$this->getIdsucursal()."' AND fecha='".$this->getFecha()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdsucursal() && $this->getFecha())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_cierrehipoteca_c WHERE 1 AND idsucursal='".$this->getIdsucursal()."' AND fecha='".$this->getFecha()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* B�squeda del registro por la llave primaria */
  public static function selectByPK($vIdsucursal, $vFecha)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idsucursal, fecha, nombresucursal, nombreadministrador, ingresototal, salidatotal, saldototal, observacion, fecharegistro, usuarioregistro, idcolaborador FROM cr_cierrehipoteca_c WHERE 1 AND idsucursal='".$vIdsucursal."' AND fecha='".$vFecha."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrCierrehipotecaCDP = new CrCierrehipotecaCDP();
    $o_CrCierrehipotecaCDP->setIdsucursal($o_propel->idsucursal);
    $o_CrCierrehipotecaCDP->setFecha($o_propel->fecha);
    $o_CrCierrehipotecaCDP->setMoneda($o_propel->moneda);
    $o_CrCierrehipotecaCDP->setNombresucursal($o_propel->nombresucursal);
    $o_CrCierrehipotecaCDP->setNombreadministrador($o_propel->nombreadministrador);
    $o_CrCierrehipotecaCDP->setIngresototal($o_propel->ingresototal);
    $o_CrCierrehipotecaCDP->setIngresototalDeposito($o_propel->ingresototaldeposito);
    $o_CrCierrehipotecaCDP->setSalidatotal($o_propel->salidatotal);
    $o_CrCierrehipotecaCDP->setSaldototal($o_propel->saldototal);
    $o_CrCierrehipotecaCDP->setObservacion($o_propel->observacion);
    $o_CrCierrehipotecaCDP->setFecharegistro($o_propel->fecharegistro);
    $o_CrCierrehipotecaCDP->setUsuarioregistro($o_propel->usuarioregistro);
    $o_CrCierrehipotecaCDP->setIdcolaborador($o_propel->idcolaborador);
    return $o_CrCierrehipotecaCDP;
  }
}